/* A Bison parser, made from ../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	INT	257
# define	NULL_PTR	258
# define	CHARLIT	259
# define	FLOAT	260
# define	COLONCOLON	261
# define	STRING	262
# define	NAME	263
# define	DOT_ID	264
# define	DOT_ALL	265
# define	SPECIAL_VARIABLE	266
# define	ASSIGN	267
# define	_AND_	268
# define	OR	269
# define	XOR	270
# define	THEN	271
# define	ELSE	272
# define	NOTEQUAL	273
# define	LEQ	274
# define	GEQ	275
# define	IN	276
# define	DOTDOT	277
# define	UNARY	278
# define	MOD	279
# define	REM	280
# define	STARSTAR	281
# define	ABS	282
# define	NOT	283
# define	VAR	284
# define	ARROW	285
# define	TICK_ACCESS	286
# define	TICK_ADDRESS	287
# define	TICK_FIRST	288
# define	TICK_LAST	289
# define	TICK_LENGTH	290
# define	TICK_MAX	291
# define	TICK_MIN	292
# define	TICK_MODULUS	293
# define	TICK_POS	294
# define	TICK_RANGE	295
# define	TICK_SIZE	296
# define	TICK_TAG	297
# define	TICK_VAL	298
# define	NEW	299
# define	OTHERS	300

#line 39 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"


#include "defs.h"
#include "gdb_string.h"
#include <ctype.h>
#include "expression.h"
#include "value.h"
#include "parser-defs.h"
#include "language.h"
#include "ada-lang.h"
#include "bfd.h" /* Required by objfiles.h.  */
#include "symfile.h" /* Required by objfiles.h.  */
#include "objfiles.h" /* For have_full_symbols and have_partial_symbols */
#include "frame.h"
#include "block.h"

/* Remap normal yacc parser interface names (yyparse, yylex, yyerror, etc),
   as well as gratuitiously global symbol names, so we can have multiple
   yacc generated parsers in gdb.  These are only the variables
   produced by yacc.  If other parser generators (bison, byacc, etc) produce
   additional global names that conflict at link time, then those parser
   generators need to be fixed instead of adding those names to this list.  */

/* NOTE: This is clumsy, especially since BISON and FLEX provide --prefix
   options.  I presume we are maintaining it to accommodate systems
   without BISON?  (PNH) */

#define	yymaxdepth ada_maxdepth
#define	yyparse	_ada_parse	/* ada_parse calls this after  initialization */
#define	yylex	ada_lex
#define	yyerror	ada_error
#define	yylval	ada_lval
#define	yychar	ada_char
#define	yydebug	ada_debug
#define	yypact	ada_pact
#define	yyr1	ada_r1
#define	yyr2	ada_r2
#define	yydef	ada_def
#define	yychk	ada_chk
#define	yypgo	ada_pgo
#define	yyact	ada_act
#define	yyexca	ada_exca
#define yyerrflag ada_errflag
#define yynerrs	ada_nerrs
#define	yyps	ada_ps
#define	yypv	ada_pv
#define	yys	ada_s
#define	yy_yys	ada_yys
#define	yystate	ada_state
#define	yytmp	ada_tmp
#define	yyv	ada_v
#define	yy_yyv	ada_yyv
#define	yyval	ada_val
#define	yylloc	ada_lloc
#define yyreds	ada_reds		/* With YYDEBUG defined */
#define yytoks	ada_toks		/* With YYDEBUG defined */
#define yyname	ada_name		/* With YYDEBUG defined */
#define yyrule	ada_rule		/* With YYDEBUG defined */

#ifndef YYDEBUG
#define	YYDEBUG	1		/* Default to yydebug support */
#endif

#define YYFPRINTF parser_fprintf

struct name_info {
  struct symbol *sym;
  struct minimal_symbol *msym;
  struct block *block;
  struct stoken stoken;
};

static struct stoken empty_stoken = { "", 0 };

/* If expression is in the context of TYPE'(...), then TYPE, else
 * NULL.  */
static struct type *type_qualifier;

int yyparse (void);

static int yylex (void);

void yyerror (char *);

static struct stoken string_to_operator (struct stoken);

static void write_int (LONGEST, struct type *);

static void write_object_renaming (struct block *, struct symbol *, int);

static struct type* write_var_or_type (struct block *, struct stoken);

static void write_name_assoc (struct stoken);

static void write_exp_op_with_string (enum exp_opcode, struct stoken);

static struct block *block_lookup (struct block *, char *);

static LONGEST convert_char_literal (struct type *, LONGEST);

static void write_ambiguous_var (struct block *, char *, int);

static struct type *type_int (void);

static struct type *type_long (void);

static struct type *type_long_long (void);

static struct type *type_float (void);

static struct type *type_double (void);

static struct type *type_long_double (void);

static struct type *type_char (void);

static struct type *type_system_address (void);


#line 159 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
#ifndef YYSTYPE
typedef union
  {
    LONGEST lval;
    struct {
      LONGEST val;
      struct type *type;
    } typed_val;
    struct {
      DOUBLEST dval;
      struct type *type;
    } typed_val_float;
    struct type *tval;
    struct stoken sval;
    struct block *bval;
    struct internalvar *ivar;
  } yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		231
#define	YYFLAG		-32768
#define	YYNTBASE	67

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 300 ? yytranslate[x] : 97)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    30,    62,
      56,    61,    32,    28,    63,    29,    55,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    60,
      21,    19,    22,     2,    27,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    57,     2,    66,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    64,    41,    65,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    20,    23,    24,    25,    26,    31,    34,
      35,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    58,
      59
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     8,    12,    15,    18,    23,    28,
      29,    37,    38,    45,    52,    56,    58,    60,    62,    64,
      67,    70,    73,    76,    77,    79,    83,    87,    93,    98,
     102,   106,   110,   114,   118,   122,   126,   130,   134,   136,
     140,   144,   148,   154,   160,   164,   171,   178,   183,   187,
     191,   195,   197,   199,   201,   203,   205,   207,   211,   215,
     220,   225,   229,   233,   238,   243,   247,   251,   254,   257,
     261,   265,   269,   272,   275,   283,   291,   297,   303,   306,
     307,   311,   313,   315,   316,   318,   320,   322,   324,   326,
     329,   331,   334,   337,   341,   344,   348,   352,   354,   357,
     360,   363,   367,   369,   371,   375,   379,   381,   382,   387,
     391,   392,   399,   400,   405,   409,   410,   417,   420,   423
};
static const short yyrhs[] =
{
      68,     0,    75,     0,    68,    60,    75,     0,    69,    13,
      75,     0,    69,    11,     0,    69,    10,     0,    69,    56,
      73,    61,     0,    84,    56,    73,    61,     0,     0,    84,
      62,    71,    70,    56,    75,    61,     0,     0,    69,    56,
      72,    26,    72,    61,     0,    84,    56,    72,    26,    72,
      61,     0,    56,    68,    61,     0,    84,     0,    12,     0,
      86,     0,    69,     0,    29,    72,     0,    28,    72,     0,
      38,    72,     0,    37,    72,     0,     0,    75,     0,     9,
      40,    75,     0,    73,    63,    75,     0,    73,    63,     9,
      40,    75,     0,    64,    84,    65,    72,     0,    72,    36,
      72,     0,    72,    32,    72,     0,    72,    33,    72,     0,
      72,    35,    72,     0,    72,    34,    72,     0,    72,    27,
      72,     0,    72,    28,    72,     0,    72,    30,    72,     0,
      72,    29,    72,     0,    72,     0,    72,    19,    72,     0,
      72,    20,    72,     0,    72,    23,    72,     0,    72,    25,
      72,    26,    72,     0,    72,    25,    69,    51,    81,     0,
      72,    25,    84,     0,    72,    38,    25,    72,    26,    72,
       0,    72,    38,    25,    69,    51,    81,     0,    72,    38,
      25,    84,     0,    72,    24,    72,     0,    72,    21,    72,
       0,    72,    22,    72,     0,    74,     0,    76,     0,    77,
       0,    78,     0,    79,     0,    80,     0,    74,    14,    74,
       0,    76,    14,    74,     0,    74,    14,    17,    74,     0,
      77,    14,    17,    74,     0,    74,    15,    74,     0,    78,
      15,    74,     0,    74,    15,    18,    74,     0,    79,    15,
      18,    74,     0,    74,    16,    74,     0,    80,    16,    74,
       0,    69,    42,     0,    69,    43,     0,    69,    44,    81,
       0,    69,    45,    81,     0,    69,    46,    81,     0,    69,
      52,     0,    69,    53,     0,    83,    48,    56,    75,    63,
      75,    61,     0,    83,    47,    56,    75,    63,    75,    61,
       0,    83,    50,    56,    75,    61,     0,    82,    54,    56,
      75,    61,     0,    82,    49,     0,     0,    56,     3,    61,
       0,    84,     0,    82,     0,     0,     3,     0,     5,     0,
       6,     0,     4,     0,     8,     0,    58,     9,     0,     9,
       0,    85,     9,     0,     9,    42,     0,    85,     9,    42,
       0,     9,     7,     0,    85,     9,     7,     0,    56,    87,
      61,     0,    89,     0,    88,    75,     0,    88,    89,     0,
      75,    63,     0,    88,    75,    63,     0,    90,     0,    91,
       0,    91,    63,    89,     0,    59,    40,    75,     0,    92,
       0,     0,     9,    40,    93,    75,     0,    72,    40,    75,
       0,     0,    72,    26,    72,    40,    94,    75,     0,     0,
       9,    41,    95,    92,     0,    72,    41,    92,     0,     0,
      72,    26,    72,    41,    96,    92,     0,    32,    69,     0,
      30,    69,     0,    69,    57,    75,    66,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   224,   228,   229,   231,   236,   240,   244,   250,   269,
     269,   281,   284,   287,   295,   306,   316,   320,   323,   326,
     330,   334,   338,   342,   345,   347,   349,   351,   355,   368,
     372,   376,   380,   384,   388,   392,   396,   400,   404,   407,
     411,   415,   419,   421,   426,   434,   438,   444,   455,   459,
     463,   467,   468,   469,   470,   471,   472,   475,   478,   482,
     485,   489,   492,   496,   499,   503,   505,   517,   519,   525,
     528,   531,   534,   536,   538,   540,   542,   544,   546,   550,
     552,   556,   566,   568,   575,   579,   586,   594,   598,   604,
     608,   610,   612,   620,   631,   633,   637,   646,   648,   654,
     658,   665,   673,   675,   676,   680,   684,   698,   698,   702,
     704,   704,   709,   709,   712,   714,   714,   722,   724,   726
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "NULL_PTR", "CHARLIT", "FLOAT", 
  "COLONCOLON", "STRING", "NAME", "DOT_ID", "DOT_ALL", "SPECIAL_VARIABLE", 
  "ASSIGN", "_AND_", "OR", "XOR", "THEN", "ELSE", "'='", "NOTEQUAL", 
  "'<'", "'>'", "LEQ", "GEQ", "IN", "DOTDOT", "'@'", "'+'", "'-'", "'&'", 
  "UNARY", "'*'", "'/'", "MOD", "REM", "STARSTAR", "ABS", "NOT", "VAR", 
  "ARROW", "'|'", "TICK_ACCESS", "TICK_ADDRESS", "TICK_FIRST", 
  "TICK_LAST", "TICK_LENGTH", "TICK_MAX", "TICK_MIN", "TICK_MODULUS", 
  "TICK_POS", "TICK_RANGE", "TICK_SIZE", "TICK_TAG", "TICK_VAL", "'.'", 
  "'('", "'['", "NEW", "OTHERS", "';'", "')'", "'\\''", "','", "'{'", 
  "'}'", "']'", "start", "exp1", "primary", "@1", "save_qualifier", 
  "simple_exp", "arglist", "relation", "exp", "and_exp", "and_then_exp", 
  "or_exp", "or_else_exp", "xor_exp", "tick_arglist", "type_prefix", 
  "opt_type_prefix", "var_or_type", "block", "aggregate", 
  "aggregate_component_list", "positional_list", "component_groups", 
  "others", "component_group", "component_associations", "@2", "@3", "@4", 
  "@5", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    67,    68,    68,    68,    69,    69,    69,    69,    70,
      69,    71,    69,    69,    69,    69,    69,    69,    72,    72,
      72,    72,    72,    73,    73,    73,    73,    73,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    75,    75,    75,    75,    75,    75,    76,    76,    77,
      77,    78,    78,    79,    79,    80,    80,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    81,
      81,    82,    83,    83,    69,    69,    69,    69,    69,    69,
      84,    84,    84,    84,    85,    85,    86,    87,    87,    87,
      88,    88,    89,    89,    89,    90,    91,    93,    92,    92,
      94,    92,    95,    92,    92,    96,    92,    69,    69,    69
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     3,     3,     2,     2,     4,     4,     0,
       7,     0,     6,     6,     3,     1,     1,     1,     1,     2,
       2,     2,     2,     0,     1,     3,     3,     5,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       3,     3,     5,     5,     3,     6,     6,     4,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     3,     4,
       4,     3,     3,     4,     4,     3,     3,     2,     2,     3,
       3,     3,     2,     2,     7,     7,     5,     5,     2,     0,
       3,     1,     1,     0,     1,     1,     1,     1,     1,     2,
       1,     2,     2,     3,     2,     3,     3,     1,     2,     2,
       2,     3,     1,     1,     3,     3,     1,     0,     4,     3,
       0,     6,     0,     4,     3,     0,     6,     2,     2,     4
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      83,    84,    87,    85,    86,    88,    90,    16,    83,    83,
      83,    83,    83,    83,    83,     0,     0,     1,    18,    38,
      51,     2,    52,    53,    54,    55,    56,    82,     0,    15,
       0,    17,    94,    92,    18,    20,    19,   118,   117,    22,
      21,    90,     0,     0,    38,     2,     0,    83,    97,   102,
     103,   106,    89,     0,    83,     6,     5,    83,    67,    68,
      79,    79,    79,    72,    73,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,     0,    83,    83,    83,    83,     0,    83,
       0,    83,    78,     0,     0,     0,     0,    83,    11,    91,
     107,   112,    83,    14,    83,    83,    83,   100,    96,    98,
      99,    83,    83,     3,     4,     0,    69,    70,    71,    90,
      38,     0,    24,     0,    39,    40,    49,    50,    41,    48,
      18,     0,    15,    34,    35,    37,    36,    30,    31,    33,
      32,    29,    83,    83,    57,    83,    61,    65,    58,    83,
      62,    83,    66,    83,    83,    83,    83,    38,     0,     9,
      95,    93,    83,    83,   105,     0,   109,     0,   114,   101,
     104,    28,     0,    83,    83,     7,    83,   119,    79,    83,
      18,     0,    15,    59,    63,    60,    64,     0,     0,     0,
       0,    83,     8,     0,   108,   113,   110,   115,    80,    25,
       0,    90,    26,    43,    42,    79,    83,    77,    83,    83,
      76,     0,    83,    83,    83,    12,    83,    46,    45,     0,
       0,    13,     0,   111,   116,    27,    75,    74,    10,     0,
       0,     0
};

static const short yydefgoto[] =
{
     229,    17,    34,   193,   159,    19,   121,    20,   122,    22,
      23,    24,    25,    26,   116,    27,    28,    29,    30,    31,
      46,    47,    48,    49,    50,    51,   162,   213,   163,   214
};

static const short yypact[] =
{
     404,-32768,-32768,-32768,-32768,-32768,    16,-32768,   404,   404,
     119,   119,   404,   404,   290,    19,    39,   -53,   148,   605,
       6,-32768,    -3,    49,    38,    50,    48,   -30,     2,   204,
      58,-32768,-32768,-32768,   523,   297,   297,    -1,    -1,   297,
     297,    -2,    28,   -15,   562,    24,    29,   290,-32768,-32768,
      30,-32768,-32768,    31,   404,-32768,-32768,   404,-32768,-32768,
      42,    42,    42,-32768,-32768,   279,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,    74,   347,   362,   404,   404,    83,   404,
      85,   404,-32768,    51,    53,    55,    57,   279,-32768,    20,
  -32768,-32768,   404,-32768,   404,   404,   419,-32768,-32768,    41,
  -32768,   290,   404,-32768,-32768,   103,-32768,-32768,-32768,     1,
     525,   -27,-32768,    54,   659,   659,   659,   659,   659,   659,
     470,   474,   172,   668,   297,   297,   297,    78,    78,    78,
      78,    78,   404,   404,-32768,   404,-32768,-32768,-32768,   404,
  -32768,   404,-32768,   404,   404,   404,   404,   585,   -19,-32768,
  -32768,-32768,   404,   419,-32768,   633,-32768,   618,-32768,-32768,
  -32768,-32768,    56,   404,   404,-32768,   461,-32768,    42,   404,
     486,   649,   215,-32768,-32768,-32768,-32768,    60,    63,    67,
      75,   404,-32768,    86,-32768,-32768,-32768,-32768,-32768,-32768,
     105,    52,-32768,-32768,   659,    42,   404,-32768,   404,   404,
  -32768,   212,   404,   404,   419,-32768,   404,-32768,   659,    82,
      87,-32768,    89,-32768,-32768,-32768,-32768,-32768,-32768,   144,
     147,-32768
};

static const short yypgoto[] =
{
  -32768,   138,    15,-32768,-32768,     4,    22,   -54,     0,-32768,
  -32768,-32768,-32768,-32768,   -60,-32768,-32768,   -13,-32768,-32768,
  -32768,-32768,   -41,-32768,-32768,  -102,-32768,-32768,-32768,-32768
};


#define	YYLAST		704


static const short yytable[] =
{
      21,   117,   118,    53,   168,    32,   110,    54,    32,    55,
      56,    87,    35,    36,    45,    18,    39,    40,    44,    92,
      84,    85,    86,    32,    93,    37,    38,   160,    52,    18,
     144,   146,   147,   148,   175,   150,   176,   152,   100,   101,
      33,   173,   192,    33,   176,    54,   103,   109,     6,    94,
      95,    44,    96,    89,   113,    65,    66,   114,    33,    32,
     132,   195,   161,    88,    91,    90,   123,    99,   102,   120,
     170,   124,   125,   126,   127,   128,   129,   131,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   107,   130,   183,
     108,   184,   216,   111,    33,   185,   112,   186,   115,   142,
     149,   157,   164,   151,   169,   166,   172,   153,   165,   154,
     167,   155,   224,   156,    82,   167,   171,   198,   203,   158,
     177,   207,     1,     2,     3,     4,   208,     5,     6,   182,
     209,     7,    74,    75,    76,    77,   210,    78,    79,    80,
      81,    82,   212,   226,   230,   217,   181,   231,   227,    10,
     228,    11,    43,   187,   188,   189,   190,   180,    55,    56,
       0,    57,   194,     0,     0,     0,   215,   167,     0,     0,
       0,     0,   -44,   199,     0,    14,   202,    15,   200,     0,
       0,     0,     0,   204,     0,     0,   -44,   -44,   -44,     0,
      58,    59,    60,    61,    62,   211,     0,     0,     0,     0,
      63,    64,     0,     0,    65,    66,     0,     0,   219,   220,
     218,     0,   222,   223,     0,   -47,   225,     0,   167,   -81,
     -81,   -81,   -81,     0,     0,     0,   -81,     0,    97,   -47,
     -47,   -47,   -44,   -44,    98,   -44,     0,     0,   -44,    74,
      75,    76,    77,     0,    78,    79,    80,    81,    82,     0,
       0,   -81,   -81,   -81,   -81,     0,     0,     0,   -81,     0,
      97,     0,   -81,   -81,   -81,   -81,    98,     0,     0,   -81,
       0,    97,     0,   221,     0,   -47,   -47,    98,   -47,     0,
       0,   -47,     1,     2,     3,     4,     0,     5,   119,     0,
       0,     7,     0,     1,     2,     3,     4,     0,     5,    41,
       0,     0,     7,     0,     0,     0,     0,     8,     9,    10,
       0,    11,     0,     0,     0,     0,    12,    13,     8,     9,
      10,     0,    11,     0,     0,     0,     0,    12,    13,    78,
      79,    80,    81,    82,     0,    14,     0,    15,     0,     0,
     -23,     0,   -23,    16,     0,     0,    14,     0,    15,    42,
       1,     2,     3,     4,    16,     5,     6,     0,     0,     7,
       0,     0,     0,     0,   143,     1,     2,     3,     4,     0,
       5,     6,     0,     0,     7,     8,     9,    10,     0,    11,
     145,     0,     0,     0,    12,    13,     0,     0,     0,     0,
       8,     9,    10,     0,    11,     0,     0,     0,     0,    12,
      13,     0,     0,    14,     0,    15,     0,     1,     2,     3,
       4,    16,     5,     6,     0,     0,     7,     0,    14,     0,
      15,     0,     1,     2,     3,     4,    16,     5,    41,     0,
       0,     7,     8,     9,    10,     0,    11,     0,     0,     0,
       0,    12,    13,     0,     0,     0,     0,     8,     9,    10,
       0,    11,     0,     0,     0,     0,    12,    13,     0,     0,
      14,     0,    15,     0,     1,     2,     3,     4,    16,     5,
     201,     0,     0,     7,     0,    14,     0,    15,     0,     0,
      55,    56,     0,    16,     0,     0,     0,     0,     0,     8,
       9,    10,     0,    11,     0,     0,    55,    56,    12,    13,
     179,    74,    75,    76,    77,     0,    78,    79,    80,    81,
      82,     0,    58,    59,    60,    61,    62,    14,     0,    15,
       0,   178,    63,    64,     0,    16,    65,    66,    58,    59,
      60,    61,    62,    55,    56,     0,     0,   205,    63,    64,
       0,     0,    65,    66,    67,    68,    69,    70,    71,    72,
      73,   174,    74,    75,    76,    77,     0,    78,    79,    80,
      81,    82,     0,    83,     0,    58,    59,    60,    61,    62,
       0,     0,     0,     0,     0,    63,    64,     0,     0,    65,
      66,    67,    68,    69,    70,    71,    72,    73,   104,    74,
      75,    76,    77,     0,    78,    79,    80,    81,    82,     0,
      83,     0,   105,   106,    67,    68,    69,    70,    71,    72,
      73,   191,    74,    75,    76,    77,     0,    78,    79,    80,
      81,    82,     0,    83,    67,    68,    69,    70,    71,    72,
      73,     0,    74,    75,    76,    77,     0,    78,    79,    80,
      81,    82,     0,    83,   104,    74,    75,    76,    77,     0,
      78,    79,    80,    81,    82,     0,     0,     0,   105,   106,
      74,    75,    76,    77,     0,    78,    79,    80,    81,    82,
       0,     0,     0,   196,   197,   206,    74,    75,    76,    77,
       0,    78,    79,    80,    81,    82,    74,    75,    76,    77,
       0,    78,    79,    80,    81,    82,    75,    76,    77,     0,
      78,    79,    80,    81,    82
};

static const short yycheck[] =
{
       0,    61,    62,    16,   106,     7,    47,    60,     7,    10,
      11,    14,     8,     9,    14,     0,    12,    13,    14,    49,
      14,    15,    16,     7,    54,    10,    11,     7,     9,    14,
      84,    85,    86,    87,    61,    89,    63,    91,    40,    41,
      42,    40,    61,    42,    63,    60,    61,    47,     9,    47,
      48,    47,    50,    15,    54,    56,    57,    57,    42,     7,
      73,   163,    42,    14,    16,    15,    66,     9,    40,    65,
     111,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    63,    73,   143,
      61,   145,    40,    63,    42,   149,    65,   151,    56,    25,
      17,    97,   102,    18,    63,   105,     3,    56,   104,    56,
     106,    56,   214,    56,    36,   111,   112,    61,   178,    97,
      66,    61,     3,     4,     5,     6,    63,     8,     9,   142,
      63,    12,    27,    28,    29,    30,    61,    32,    33,    34,
      35,    36,    56,    61,     0,   205,   142,     0,    61,    30,
      61,    32,    14,   153,   154,   155,   156,   142,    10,    11,
      -1,    13,   162,    -1,    -1,    -1,    61,   163,    -1,    -1,
      -1,    -1,     0,   173,    -1,    56,   176,    58,   174,    -1,
      -1,    -1,    -1,   179,    -1,    -1,    14,    15,    16,    -1,
      42,    43,    44,    45,    46,   191,    -1,    -1,    -1,    -1,
      52,    53,    -1,    -1,    56,    57,    -1,    -1,   208,   209,
     206,    -1,   212,   213,    -1,     0,   216,    -1,   214,    47,
      48,    49,    50,    -1,    -1,    -1,    54,    -1,    56,    14,
      15,    16,    60,    61,    62,    63,    -1,    -1,    66,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    -1,
      -1,    47,    48,    49,    50,    -1,    -1,    -1,    54,    -1,
      56,    -1,    47,    48,    49,    50,    62,    -1,    -1,    54,
      -1,    56,    -1,    61,    -1,    60,    61,    62,    63,    -1,
      -1,    66,     3,     4,     5,     6,    -1,     8,     9,    -1,
      -1,    12,    -1,     3,     4,     5,     6,    -1,     8,     9,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    28,    29,
      30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,    32,
      33,    34,    35,    36,    -1,    56,    -1,    58,    -1,    -1,
      61,    -1,    63,    64,    -1,    -1,    56,    -1,    58,    59,
       3,     4,     5,     6,    64,     8,     9,    -1,    -1,    12,
      -1,    -1,    -1,    -1,    17,     3,     4,     5,     6,    -1,
       8,     9,    -1,    -1,    12,    28,    29,    30,    -1,    32,
      18,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    -1,
      28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,
      38,    -1,    -1,    56,    -1,    58,    -1,     3,     4,     5,
       6,    64,     8,     9,    -1,    -1,    12,    -1,    56,    -1,
      58,    -1,     3,     4,     5,     6,    64,     8,     9,    -1,
      -1,    12,    28,    29,    30,    -1,    32,    -1,    -1,    -1,
      -1,    37,    38,    -1,    -1,    -1,    -1,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,    -1,
      56,    -1,    58,    -1,     3,     4,     5,     6,    64,     8,
       9,    -1,    -1,    12,    -1,    56,    -1,    58,    -1,    -1,
      10,    11,    -1,    64,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    -1,    32,    -1,    -1,    10,    11,    37,    38,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    -1,    42,    43,    44,    45,    46,    56,    -1,    58,
      -1,    51,    52,    53,    -1,    64,    56,    57,    42,    43,
      44,    45,    46,    10,    11,    -1,    -1,    51,    52,    53,
      -1,    -1,    56,    57,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    -1,    38,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    -1,    -1,    56,
      57,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    -1,
      38,    -1,    40,    41,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    -1,    38,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    -1,    38,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      -1,    -1,    -1,    40,    41,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    28,    29,    30,    -1,
      32,    33,    34,    35,    36
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/volume/hab/Linux/Ubuntu-12.04/x86_64/bison/1.35/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/volume/hab/Linux/Ubuntu-12.04/x86_64/bison/1.35/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 230 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_COMMA); }
    break;
case 4:
#line 232 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_ASSIGN); }
    break;
case 5:
#line 237 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_IND); }
    break;
case 6:
#line 241 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_op_with_string (STRUCTOP_STRUCT, yyvsp[0].sval); }
    break;
case 7:
#line 245 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{
			  write_exp_elt_opcode (OP_FUNCALL);
			  write_exp_elt_longcst (yyvsp[-1].lval);
			  write_exp_elt_opcode (OP_FUNCALL);
		        }
    break;
case 8:
#line 251 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{
			  if (yyvsp[-3].tval != NULL)
			    {
			      if (yyvsp[-1].lval != 1)
				error (_("Invalid conversion"));
			      write_exp_elt_opcode (UNOP_CAST);
			      write_exp_elt_type (yyvsp[-3].tval);
			      write_exp_elt_opcode (UNOP_CAST);
			    }
			  else
			    {
			      write_exp_elt_opcode (OP_FUNCALL);
			      write_exp_elt_longcst (yyvsp[-1].lval);
			      write_exp_elt_opcode (OP_FUNCALL);
			    }
			}
    break;
case 9:
#line 269 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ type_qualifier = yyvsp[-2].tval; }
    break;
case 10:
#line 271 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{
			  if (yyvsp[-6].tval == NULL)
			    error (_("Type required for qualification"));
			  write_exp_elt_opcode (UNOP_QUAL);
			  write_exp_elt_type (yyvsp[-6].tval);
			  write_exp_elt_opcode (UNOP_QUAL);
			  type_qualifier = yyvsp[-4].tval;
			}
    break;
case 11:
#line 281 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.tval = type_qualifier; }
    break;
case 12:
#line 286 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (TERNOP_SLICE); }
    break;
case 13:
#line 288 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ if (yyvsp[-5].tval == NULL) 
                            write_exp_elt_opcode (TERNOP_SLICE);
			  else
			    error (_("Cannot slice a type"));
			}
    break;
case 14:
#line 295 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ }
    break;
case 15:
#line 307 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ if (yyvsp[0].tval != NULL)
			    {
			      write_exp_elt_opcode (OP_TYPE);
			      write_exp_elt_type (yyvsp[0].tval);
			      write_exp_elt_opcode (OP_TYPE);
			    }
			}
    break;
case 16:
#line 317 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_dollar_variable (yyvsp[0].sval); }
    break;
case 19:
#line 327 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_NEG); }
    break;
case 20:
#line 331 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_PLUS); }
    break;
case 21:
#line 335 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_LOGICAL_NOT); }
    break;
case 22:
#line 339 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_ABS); }
    break;
case 23:
#line 342 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 0; }
    break;
case 24:
#line 346 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 25:
#line 348 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 26:
#line 350 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[-2].lval + 1; }
    break;
case 27:
#line 352 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[-4].lval + 1; }
    break;
case 28:
#line 357 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  if (yyvsp[-2].tval == NULL)
			    error (_("Type required within braces in coercion"));
			  write_exp_elt_opcode (UNOP_MEMVAL);
			  write_exp_elt_type (yyvsp[-2].tval);
			  write_exp_elt_opcode (UNOP_MEMVAL);
			}
    break;
case 29:
#line 369 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_EXP); }
    break;
case 30:
#line 373 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_MUL); }
    break;
case 31:
#line 377 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_DIV); }
    break;
case 32:
#line 381 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_REM); }
    break;
case 33:
#line 385 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_MOD); }
    break;
case 34:
#line 389 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_REPEAT); }
    break;
case 35:
#line 393 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_ADD); }
    break;
case 36:
#line 397 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_CONCAT); }
    break;
case 37:
#line 401 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_SUB); }
    break;
case 39:
#line 408 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_EQUAL); }
    break;
case 40:
#line 412 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_NOTEQUAL); }
    break;
case 41:
#line 416 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LEQ); }
    break;
case 42:
#line 420 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (TERNOP_IN_RANGE); }
    break;
case 43:
#line 422 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_IN_BOUNDS);
			  write_exp_elt_longcst ((LONGEST) yyvsp[0].lval);
			  write_exp_elt_opcode (BINOP_IN_BOUNDS);
			}
    break;
case 44:
#line 427 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  if (yyvsp[0].tval == NULL)
			    error (_("Right operand of 'in' must be type"));
			  write_exp_elt_opcode (UNOP_IN_RANGE);
		          write_exp_elt_type (yyvsp[0].tval);
		          write_exp_elt_opcode (UNOP_IN_RANGE);
			}
    break;
case 45:
#line 435 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (TERNOP_IN_RANGE);
		          write_exp_elt_opcode (UNOP_LOGICAL_NOT);
			}
    break;
case 46:
#line 439 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_IN_BOUNDS);
			  write_exp_elt_longcst ((LONGEST) yyvsp[0].lval);
			  write_exp_elt_opcode (BINOP_IN_BOUNDS);
		          write_exp_elt_opcode (UNOP_LOGICAL_NOT);
			}
    break;
case 47:
#line 445 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  if (yyvsp[0].tval == NULL)
			    error (_("Right operand of 'in' must be type"));
			  write_exp_elt_opcode (UNOP_IN_RANGE);
		          write_exp_elt_type (yyvsp[0].tval);
		          write_exp_elt_opcode (UNOP_IN_RANGE);
		          write_exp_elt_opcode (UNOP_LOGICAL_NOT);
			}
    break;
case 48:
#line 456 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_GEQ); }
    break;
case 49:
#line 460 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LESS); }
    break;
case 50:
#line 464 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_GTR); }
    break;
case 57:
#line 477 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_AND); }
    break;
case 58:
#line 479 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_AND); }
    break;
case 59:
#line 484 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LOGICAL_AND); }
    break;
case 60:
#line 486 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LOGICAL_AND); }
    break;
case 61:
#line 491 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_IOR); }
    break;
case 62:
#line 493 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_IOR); }
    break;
case 63:
#line 498 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LOGICAL_OR); }
    break;
case 64:
#line 500 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_LOGICAL_OR); }
    break;
case 65:
#line 504 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_XOR); }
    break;
case 66:
#line 506 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_BITWISE_XOR); }
    break;
case 67:
#line 518 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_ADDR); }
    break;
case 68:
#line 520 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_ADDR);
			  write_exp_elt_opcode (UNOP_CAST);
			  write_exp_elt_type (type_system_address ());
			  write_exp_elt_opcode (UNOP_CAST);
			}
    break;
case 69:
#line 526 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int (yyvsp[0].lval, type_int ());
			  write_exp_elt_opcode (OP_ATR_FIRST); }
    break;
case 70:
#line 529 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int (yyvsp[0].lval, type_int ());
			  write_exp_elt_opcode (OP_ATR_LAST); }
    break;
case 71:
#line 532 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int (yyvsp[0].lval, type_int ());
			  write_exp_elt_opcode (OP_ATR_LENGTH); }
    break;
case 72:
#line 535 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_SIZE); }
    break;
case 73:
#line 537 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_TAG); }
    break;
case 74:
#line 539 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_MIN); }
    break;
case 75:
#line 541 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_MAX); }
    break;
case 76:
#line 543 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_POS); }
    break;
case 77:
#line 545 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_VAL); }
    break;
case 78:
#line 547 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_ATR_MODULUS); }
    break;
case 79:
#line 551 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 80:
#line 553 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[-1].typed_val.val; }
    break;
case 81:
#line 558 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  if (yyvsp[0].tval == NULL)
			    error (_("Prefix must be type"));
			  write_exp_elt_opcode (OP_TYPE);
			  write_exp_elt_type (yyvsp[0].tval);
			  write_exp_elt_opcode (OP_TYPE); }
    break;
case 83:
#line 569 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_TYPE);
			  write_exp_elt_type (builtin_type_void);
			  write_exp_elt_opcode (OP_TYPE); }
    break;
case 84:
#line 576 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int ((LONGEST) yyvsp[0].typed_val.val, yyvsp[0].typed_val.type); }
    break;
case 85:
#line 580 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int (convert_char_literal (type_qualifier, yyvsp[0].typed_val.val),
			       (type_qualifier == NULL) 
			       ? yyvsp[0].typed_val.type : type_qualifier);
		  }
    break;
case 86:
#line 587 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_DOUBLE);
			  write_exp_elt_type (yyvsp[0].typed_val_float.type);
			  write_exp_elt_dblcst (yyvsp[0].typed_val_float.dval);
			  write_exp_elt_opcode (OP_DOUBLE);
			}
    break;
case 87:
#line 595 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_int (0, type_int ()); }
    break;
case 88:
#line 599 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  write_exp_op_with_string (OP_STRING, yyvsp[0].sval);
			}
    break;
case 89:
#line 605 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ error (_("NEW not implemented.")); }
    break;
case 90:
#line 609 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.tval = write_var_or_type (NULL, yyvsp[0].sval); }
    break;
case 91:
#line 611 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.tval = write_var_or_type (yyvsp[-1].bval, yyvsp[0].sval); }
    break;
case 92:
#line 613 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  yyval.tval = write_var_or_type (NULL, yyvsp[-1].sval);
			  if (yyval.tval == NULL)
			    write_exp_elt_opcode (UNOP_ADDR);
			  else
			    yyval.tval = lookup_pointer_type (yyval.tval);
			}
    break;
case 93:
#line 621 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ 
			  yyval.tval = write_var_or_type (yyvsp[-2].bval, yyvsp[-1].sval);
			  if (yyval.tval == NULL)
			    write_exp_elt_opcode (UNOP_ADDR);
			  else
			    yyval.tval = lookup_pointer_type (yyval.tval);
			}
    break;
case 94:
#line 632 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.bval = block_lookup (NULL, yyvsp[-1].sval.ptr); }
    break;
case 95:
#line 634 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.bval = block_lookup (yyvsp[-2].bval, yyvsp[-1].sval.ptr); }
    break;
case 96:
#line 639 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{
			  write_exp_elt_opcode (OP_AGGREGATE);
			  write_exp_elt_longcst (yyvsp[-1].lval);
			  write_exp_elt_opcode (OP_AGGREGATE);
		        }
    break;
case 97:
#line 647 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[0].lval; }
    break;
case 98:
#line 649 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_POSITIONAL);
			  write_exp_elt_longcst (yyvsp[-1].lval);
			  write_exp_elt_opcode (OP_POSITIONAL);
			  yyval.lval = yyvsp[-1].lval + 1;
			}
    break;
case 99:
#line 655 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[-1].lval + yyvsp[0].lval; }
    break;
case 100:
#line 660 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_POSITIONAL);
			  write_exp_elt_longcst (0);
			  write_exp_elt_opcode (OP_POSITIONAL);
			  yyval.lval = 1;
			}
    break;
case 101:
#line 666 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_POSITIONAL);
			  write_exp_elt_longcst (yyvsp[-2].lval);
			  write_exp_elt_opcode (OP_POSITIONAL);
			  yyval.lval = yyvsp[-2].lval + 1; 
			}
    break;
case 102:
#line 674 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 103:
#line 675 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 104:
#line 677 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[0].lval + 1; }
    break;
case 105:
#line 681 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_OTHERS); }
    break;
case 106:
#line 686 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{
			  write_exp_elt_opcode (OP_CHOICES);
			  write_exp_elt_longcst (yyvsp[0].lval);
			  write_exp_elt_opcode (OP_CHOICES);
		        }
    break;
case 107:
#line 700 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_name_assoc (yyvsp[-1].sval); }
    break;
case 108:
#line 701 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 109:
#line 703 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 110:
#line 705 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_DISCRETE_RANGE);
			  write_exp_op_with_string (OP_NAME, empty_stoken);
			}
    break;
case 111:
#line 708 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = 1; }
    break;
case 112:
#line 710 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_name_assoc (yyvsp[-1].sval); }
    break;
case 113:
#line 711 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[0].lval + 1; }
    break;
case 114:
#line 713 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[0].lval + 1; }
    break;
case 115:
#line 715 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (OP_DISCRETE_RANGE); }
    break;
case 116:
#line 716 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ yyval.lval = yyvsp[0].lval + 1; }
    break;
case 117:
#line 723 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_IND); }
    break;
case 118:
#line 725 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (UNOP_ADDR); }
    break;
case 119:
#line 727 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"
{ write_exp_elt_opcode (BINOP_SUBSCRIPT); }
    break;
}

#line 705 "/volume/hab/Linux/Ubuntu-12.04/x86_64/bison/1.35/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 730 "../../../../../../../src/gpl-dist/gdb/gdb/ada-exp.y"


/* yylex defined in ada-lex.c: Reads one token, getting characters */
/* through lexptr.  */

/* Remap normal flex interface names (yylex) as well as gratuitiously */
/* global symbol names, so we can have multiple flex-generated parsers */
/* in gdb.  */

/* (See note above on previous definitions for YACC.) */

#define yy_create_buffer ada_yy_create_buffer
#define yy_delete_buffer ada_yy_delete_buffer
#define yy_init_buffer ada_yy_init_buffer
#define yy_load_buffer_state ada_yy_load_buffer_state
#define yy_switch_to_buffer ada_yy_switch_to_buffer
#define yyrestart ada_yyrestart
#define yytext ada_yytext
#define yywrap ada_yywrap

static struct obstack temp_parse_space;

/* The following kludge was found necessary to prevent conflicts between */
/* defs.h and non-standard stdlib.h files.  */
#define qsort __qsort__dummy
#include "ada-lex.c"

int
ada_parse (void)
{
  lexer_init (yyin);		/* (Re-)initialize lexer.  */
  type_qualifier = NULL;
  obstack_free (&temp_parse_space, NULL);
  obstack_init (&temp_parse_space);

  return _ada_parse ();
}

void
yyerror (char *msg)
{
  error (_("Error in expression, near `%s'."), lexptr);
}

/* The operator name corresponding to operator symbol STRING (adds
   quotes and maps to lower-case).  Destroys the previous contents of
   the array pointed to by STRING.ptr.  Error if STRING does not match
   a valid Ada operator.  Assumes that STRING.ptr points to a
   null-terminated string and that, if STRING is a valid operator
   symbol, the array pointed to by STRING.ptr contains at least
   STRING.length+3 characters.  */

static struct stoken
string_to_operator (struct stoken string)
{
  int i;

  for (i = 0; ada_opname_table[i].encoded != NULL; i += 1)
    {
      if (string.length == strlen (ada_opname_table[i].decoded)-2
	  && strncasecmp (string.ptr, ada_opname_table[i].decoded+1,
			  string.length) == 0)
	{
	  strncpy (string.ptr, ada_opname_table[i].decoded,
		   string.length+2);
	  string.length += 2;
	  return string;
	}
    }
  error (_("Invalid operator symbol `%s'"), string.ptr);
}

/* Emit expression to access an instance of SYM, in block BLOCK (if
 * non-NULL), and with :: qualification ORIG_LEFT_CONTEXT.  */
static void
write_var_from_sym (struct block *orig_left_context,
		    struct block *block,
		    struct symbol *sym)
{
  if (orig_left_context == NULL && symbol_read_needs_frame (sym))
    {
      if (innermost_block == 0
	  || contained_in (block, innermost_block))
	innermost_block = block;
    }

  write_exp_elt_opcode (OP_VAR_VALUE);
  write_exp_elt_block (block);
  write_exp_elt_sym (sym);
  write_exp_elt_opcode (OP_VAR_VALUE);
}

/* Write integer constant ARG of type TYPE.  */

static void
write_int (LONGEST arg, struct type *type)
{
  write_exp_elt_opcode (OP_LONG);
  write_exp_elt_type (type);
  write_exp_elt_longcst (arg);
  write_exp_elt_opcode (OP_LONG);
}

/* Write an OPCODE, string, OPCODE sequence to the current expression.  */
static void
write_exp_op_with_string (enum exp_opcode opcode, struct stoken token)
{
  write_exp_elt_opcode (opcode);
  write_exp_string (token);
  write_exp_elt_opcode (opcode);
}
  
/* Emit expression corresponding to the renamed object designated by
 * the type RENAMING, which must be the referent of an object renaming
 * type, in the context of ORIG_LEFT_CONTEXT.  MAX_DEPTH is the maximum
 * number of cascaded renamings to allow.  */
static void
write_object_renaming (struct block *orig_left_context, 
		       struct symbol *renaming, int max_depth)
{
  const char *qualification = SYMBOL_LINKAGE_NAME (renaming);
  const char *simple_tail;
  const char *expr = TYPE_FIELD_NAME (SYMBOL_TYPE (renaming), 0);
  const char *suffix;
  char *name;
  struct symbol *sym;
  enum { SIMPLE_INDEX, LOWER_BOUND, UPPER_BOUND } slice_state;

  if (max_depth <= 0)
    error (_("Could not find renamed symbol"));

  /* if orig_left_context is null, then use the currently selected
     block; otherwise we might fail our symbol lookup below.  */
  if (orig_left_context == NULL)
    orig_left_context = get_selected_block (NULL);

  for (simple_tail = qualification + strlen (qualification);
       simple_tail != qualification; simple_tail -= 1)
    {
      if (*simple_tail == '.')
	{
	  simple_tail += 1;
	  break;
	}
      else if (strncmp (simple_tail, "__", 2) == 0)
	{
	  simple_tail += 2;
	  break;
	}
    }

  suffix = strstr (expr, "___XE");
  if (suffix == NULL)
    goto BadEncoding;

  name = (char *) obstack_alloc (&temp_parse_space, suffix - expr + 1);
  strncpy (name, expr, suffix-expr);
  name[suffix-expr] = '\000';
  sym = lookup_symbol (name, orig_left_context, VAR_DOMAIN, 0, NULL);
  if (sym == NULL)
    error (_("Could not find renamed variable: %s"), ada_decode (name));
  if (ada_is_object_renaming (sym))
    write_object_renaming (orig_left_context, sym, max_depth-1);
  else
    write_var_from_sym (orig_left_context, block_found, sym);

  suffix += 5;
  slice_state = SIMPLE_INDEX;
  while (*suffix == 'X')
    {
      suffix += 1;

      switch (*suffix) {
      case 'A':
        suffix += 1;
        write_exp_elt_opcode (UNOP_IND);
        break;
      case 'L':
	slice_state = LOWER_BOUND;
      case 'S':
	suffix += 1;
	if (isdigit (*suffix))
	  {
	    char *next;
	    long val = strtol (suffix, &next, 10);
	    if (next == suffix)
	      goto BadEncoding;
	    suffix = next;
	    write_exp_elt_opcode (OP_LONG);
	    write_exp_elt_type (type_int ());
	    write_exp_elt_longcst ((LONGEST) val);
	    write_exp_elt_opcode (OP_LONG);
	  }
	else
	  {
	    const char *end;
	    char *index_name;
	    int index_len;
	    struct symbol *index_sym;

	    end = strchr (suffix, 'X');
	    if (end == NULL)
	      end = suffix + strlen (suffix);

	    index_len = simple_tail - qualification + 2 + (suffix - end) + 1;
	    index_name
	      = (char *) obstack_alloc (&temp_parse_space, index_len);
	    memset (index_name, '\000', index_len);
	    strncpy (index_name, qualification, simple_tail - qualification);
	    index_name[simple_tail - qualification] = '\000';
	    strncat (index_name, suffix, suffix-end);
	    suffix = end;

	    index_sym =
	      lookup_symbol (index_name, NULL, VAR_DOMAIN, 0, NULL);
	    if (index_sym == NULL)
	      error (_("Could not find %s"), index_name);
	    write_var_from_sym (NULL, block_found, sym);
	  }
	if (slice_state == SIMPLE_INDEX)
	  {
	    write_exp_elt_opcode (OP_FUNCALL);
	    write_exp_elt_longcst ((LONGEST) 1);
	    write_exp_elt_opcode (OP_FUNCALL);
	  }
	else if (slice_state == LOWER_BOUND)
	  slice_state = UPPER_BOUND;
	else if (slice_state == UPPER_BOUND)
	  {
	    write_exp_elt_opcode (TERNOP_SLICE);
	    slice_state = SIMPLE_INDEX;
	  }
	break;

      case 'R':
	{
	  struct stoken field_name;
	  const char *end;
	  suffix += 1;

	  if (slice_state != SIMPLE_INDEX)
	    goto BadEncoding;
	  end = strchr (suffix, 'X');
	  if (end == NULL)
	    end = suffix + strlen (suffix);
	  field_name.length = end - suffix;
	  field_name.ptr = xmalloc (end - suffix + 1);
	  strncpy (field_name.ptr, suffix, end - suffix);
	  field_name.ptr[end - suffix] = '\000';
	  suffix = end;
	  write_exp_op_with_string (STRUCTOP_STRUCT, field_name);
	  break;
	}

      default:
	goto BadEncoding;
      }
    }
  if (slice_state == SIMPLE_INDEX)
    return;

 BadEncoding:
  error (_("Internal error in encoding of renaming declaration: %s"),
	 SYMBOL_LINKAGE_NAME (renaming));
}

static struct block*
block_lookup (struct block *context, char *raw_name)
{
  char *name;
  struct ada_symbol_info *syms;
  int nsyms;
  struct symtab *symtab;

  if (raw_name[0] == '\'')
    {
      raw_name += 1;
      name = raw_name;
    }
  else
    name = ada_encode (raw_name);

  nsyms = ada_lookup_symbol_list (name, context, VAR_DOMAIN, &syms);
  if (context == NULL &&
      (nsyms == 0 || SYMBOL_CLASS (syms[0].sym) != LOC_BLOCK))
    symtab = lookup_symtab (name);
  else
    symtab = NULL;

  if (symtab != NULL)
    return BLOCKVECTOR_BLOCK (BLOCKVECTOR (symtab), STATIC_BLOCK);
  else if (nsyms == 0 || SYMBOL_CLASS (syms[0].sym) != LOC_BLOCK)
    {
      if (context == NULL)
	error (_("No file or function \"%s\"."), raw_name);
      else
	error (_("No function \"%s\" in specified context."), raw_name);
    }
  else
    {
      if (nsyms > 1)
	warning (_("Function name \"%s\" ambiguous here"), raw_name);
      return SYMBOL_BLOCK_VALUE (syms[0].sym);
    }
}

static struct symbol*
select_possible_type_sym (struct ada_symbol_info *syms, int nsyms)
{
  int i;
  int preferred_index;
  struct type *preferred_type;
	  
  preferred_index = -1; preferred_type = NULL;
  for (i = 0; i < nsyms; i += 1)
    switch (SYMBOL_CLASS (syms[i].sym))
      {
      case LOC_TYPEDEF:
	if (ada_prefer_type (SYMBOL_TYPE (syms[i].sym), preferred_type))
	  {
	    preferred_index = i;
	    preferred_type = SYMBOL_TYPE (syms[i].sym);
	  }
	break;
      case LOC_REGISTER:
      case LOC_ARG:
      case LOC_REF_ARG:
      case LOC_REGPARM:
      case LOC_REGPARM_ADDR:
      case LOC_LOCAL:
      case LOC_LOCAL_ARG:
      case LOC_BASEREG:
      case LOC_BASEREG_ARG:
      case LOC_COMPUTED:
      case LOC_COMPUTED_ARG:
	return NULL;
      default:
	break;
      }
  if (preferred_type == NULL)
    return NULL;
  return syms[preferred_index].sym;
}

static struct type*
find_primitive_type (char *name)
{
  struct type *type;
  type = language_lookup_primitive_type_by_name (current_language,
						 current_gdbarch,
						 name);
  if (type == NULL && strcmp ("system__address", name) == 0)
    type = type_system_address ();

  if (type != NULL)
    {
      /* Check to see if we have a regular definition of this
	 type that just didn't happen to have been read yet.  */
      int ntypes;
      struct symbol *sym;
      char *expanded_name = 
	(char *) alloca (strlen (name) + sizeof ("standard__"));
      strcpy (expanded_name, "standard__");
      strcat (expanded_name, name);
      sym = ada_lookup_symbol (expanded_name, NULL, VAR_DOMAIN, NULL, NULL);
      if (sym != NULL && SYMBOL_CLASS (sym) == LOC_TYPEDEF)
	type = SYMBOL_TYPE (sym);
    }

  return type;
}

static int
chop_selector (char *name, int end)
{
  int i;
  for (i = end - 1; i > 0; i -= 1)
    if (name[i] == '.' || (name[i] == '_' && name[i+1] == '_'))
      return i;
  return -1;
}

/* Given that SELS is a string of the form (<sep><identifier>)*, where
   <sep> is '__' or '.', write the indicated sequence of
   STRUCTOP_STRUCT expression operators. */
static void
write_selectors (char *sels)
{
  while (*sels != '\0')
    {
      struct stoken field_name;
      char *p;
      while (*sels == '_' || *sels == '.')
	sels += 1;
      p = sels;
      while (*sels != '\0' && *sels != '.' 
	     && (sels[0] != '_' || sels[1] != '_'))
	sels += 1;
      field_name.length = sels - p;
      field_name.ptr = p;
      write_exp_op_with_string (STRUCTOP_STRUCT, field_name);
    }
}

/* Write a variable access (OP_VAR_VALUE) to ambiguous encoded name
   NAME[0..LEN-1], in block context BLOCK, to be resolved later.  Writes
   a temporary symbol that is valid until the next call to ada_parse.
   */
static void
write_ambiguous_var (struct block *block, char *name, int len)
{
  struct symbol *sym =
    obstack_alloc (&temp_parse_space, sizeof (struct symbol));
  memset (sym, 0, sizeof (struct symbol));
  SYMBOL_DOMAIN (sym) = UNDEF_DOMAIN;
  SYMBOL_LINKAGE_NAME (sym) = obsavestring (name, len, &temp_parse_space);
  SYMBOL_LANGUAGE (sym) = language_ada;

  write_exp_elt_opcode (OP_VAR_VALUE);
  write_exp_elt_block (block);
  write_exp_elt_sym (sym);
  write_exp_elt_opcode (OP_VAR_VALUE);
}


/* Look up NAME0 (an unencoded identifier or dotted name) in BLOCK (or 
   expression_block_context if NULL).  If it denotes a type, return
   that type.  Otherwise, write expression code to evaluate it as an
   object and return NULL. In this second case, NAME0 will, in general,
   have the form <name>(.<selector_name>)*, where <name> is an object
   or renaming encoded in the debugging data.  Calls error if no
   prefix <name> matches a name in the debugging data (i.e., matches
   either a complete name or, as a wild-card match, the final 
   identifier).  */

static struct type*
write_var_or_type (struct block *block, struct stoken name0)
{
  int depth;
  char *encoded_name;
  int name_len;

  if (block == NULL)
    block = expression_context_block;

  encoded_name = ada_encode (name0.ptr);
  name_len = strlen (encoded_name);
  encoded_name = obsavestring (encoded_name, name_len, &temp_parse_space);
  for (depth = 0; depth < MAX_RENAMING_CHAIN_LENGTH; depth += 1)
    {
      int tail_index;
      
      tail_index = name_len;
      while (tail_index > 0)
	{
	  int nsyms;
	  struct ada_symbol_info *syms;
	  struct symbol *type_sym;
	  int terminator = encoded_name[tail_index];

	  encoded_name[tail_index] = '\0';
	  nsyms = ada_lookup_symbol_list (encoded_name, block,
					  VAR_DOMAIN, &syms);
	  encoded_name[tail_index] = terminator;

	  /* A single symbol may rename a package or object. */

	  if (nsyms == 1 && !ada_is_object_renaming (syms[0].sym))
	    {
	      struct symbol *renaming_sym =
		ada_find_renaming_symbol (SYMBOL_LINKAGE_NAME (syms[0].sym), 
					  syms[0].block);

	      if (renaming_sym != NULL)
		syms[0].sym = renaming_sym;
	    }

	  type_sym = select_possible_type_sym (syms, nsyms);
	  if (type_sym != NULL)
	    {
	      struct type *type = SYMBOL_TYPE (type_sym);

	      if (TYPE_CODE (type) == TYPE_CODE_VOID)
		error (_("`%s' matches only void type name(s)"), name0.ptr);
	      else if (ada_is_object_renaming (type_sym))
		{
		  write_object_renaming (block, type_sym, 
					 MAX_RENAMING_CHAIN_LENGTH);
		  write_selectors (encoded_name + tail_index);
		  return NULL;
		}
	      else if (ada_renaming_type (SYMBOL_TYPE (type_sym)) != NULL)
		{
		  int result;
		  char *renaming = ada_simple_renamed_entity (type_sym);
		  int renaming_len = strlen (renaming);

		  char *new_name
		    = obstack_alloc (&temp_parse_space,
				     renaming_len + name_len - tail_index 
				     + 1);
		  strcpy (new_name, renaming);
		  xfree (renaming);
		  strcpy (new_name + renaming_len, encoded_name + tail_index);
		  encoded_name = new_name;
		  name_len = renaming_len + name_len - tail_index;
		  goto TryAfterRenaming;
		}
	      else if (tail_index == name_len)
		return type;
	      else 
		error (_("Invalid attempt to select from type: \"%s\"."), name0.ptr);
	    }
	  else if (tail_index == name_len && nsyms == 0)
	    {
	      struct type *type = find_primitive_type (encoded_name);

	      if (type != NULL)
		return type;
	    }

	  if (nsyms == 1)
	    {
	      write_var_from_sym (block, syms[0].block, syms[0].sym);
	      write_selectors (encoded_name + tail_index);
	      return NULL;
	    }
	  else if (nsyms == 0) 
	    {
	      int i;
	      struct minimal_symbol *msym 
		= ada_lookup_simple_minsym (encoded_name);
	      if (msym != NULL)
		{
		  write_exp_msymbol (msym, lookup_function_type (type_int ()),
				     type_int ());
		  /* Maybe cause error here rather than later? FIXME? */
		  write_selectors (encoded_name + tail_index);
		  return NULL;
		}

	      if (tail_index == name_len
		  && strncmp (encoded_name, "standard__", 
			      sizeof ("standard__") - 1) == 0)
		error (_("No definition of \"%s\" found."), name0.ptr);

	      tail_index = chop_selector (encoded_name, tail_index);
	    } 
	  else
	    {
	      write_ambiguous_var (block, encoded_name, tail_index);
	      write_selectors (encoded_name + tail_index);
	      return NULL;
	    }
	}

      if (!have_full_symbols () && !have_partial_symbols () && block == NULL)
	error (_("No symbol table is loaded.  Use the \"file\" command."));
      if (block == expression_context_block)
	error (_("No definition of \"%s\" in current context."), name0.ptr);
      else
	error (_("No definition of \"%s\" in specified context."), name0.ptr);
      
    TryAfterRenaming: ;
    }

  error (_("Could not find renamed symbol \"%s\""), name0.ptr);

}

/* Write a left side of a component association (e.g., NAME in NAME =>
   exp).  If NAME has the form of a selected component, write it as an
   ordinary expression.  If it is a simple variable that unambiguously
   corresponds to exactly one symbol that does not denote a type or an
   object renaming, also write it normally as an OP_VAR_VALUE.
   Otherwise, write it as an OP_NAME.

   Unfortunately, we don't know at this point whether NAME is supposed
   to denote a record component name or the value of an array index.
   Therefore, it is not appropriate to disambiguate an ambiguous name
   as we normally would, nor to replace a renaming with its referent.
   As a result, in the (one hopes) rare case that one writes an
   aggregate such as (R => 42) where R renames an object or is an
   ambiguous name, one must write instead ((R) => 42). */
   
static void
write_name_assoc (struct stoken name)
{
  if (strchr (name.ptr, '.') == NULL)
    {
      struct ada_symbol_info *syms;
      int nsyms = ada_lookup_symbol_list (name.ptr, expression_context_block,
					  VAR_DOMAIN, &syms);
      if (nsyms != 1 || SYMBOL_CLASS (syms[0].sym) == LOC_TYPEDEF)
	write_exp_op_with_string (OP_NAME, name);
      else
	write_var_from_sym (NULL, syms[0].block, syms[0].sym);
    }
  else
    if (write_var_or_type (NULL, name) != NULL)
      error (_("Invalid use of type."));
}

/* Convert the character literal whose ASCII value would be VAL to the
   appropriate value of type TYPE, if there is a translation.
   Otherwise return VAL.  Hence, in an enumeration type ('A', 'B'),
   the literal 'A' (VAL == 65), returns 0.  */

static LONGEST
convert_char_literal (struct type *type, LONGEST val)
{
  char name[7];
  int f;

  if (type == NULL || TYPE_CODE (type) != TYPE_CODE_ENUM)
    return val;
  sprintf (name, "QU%02x", (int) val);
  for (f = 0; f < TYPE_NFIELDS (type); f += 1)
    {
      if (strcmp (name, TYPE_FIELD_NAME (type, f)) == 0)
	return TYPE_FIELD_BITPOS (type, f);
    }
  return val;
}

static struct type *
type_int (void)
{
  return builtin_type (current_gdbarch)->builtin_int;
}

static struct type *
type_long (void)
{
  return builtin_type (current_gdbarch)->builtin_long;
}

static struct type *
type_long_long (void)
{
  return builtin_type (current_gdbarch)->builtin_long_long;
}

static struct type *
type_float (void)
{
  return builtin_type (current_gdbarch)->builtin_float;
}

static struct type *
type_double (void)
{
  return builtin_type (current_gdbarch)->builtin_double;
}

static struct type *
type_long_double (void)
{
  return builtin_type (current_gdbarch)->builtin_long_double;
}

static struct type *
type_char (void)
{
  return language_string_char_type (current_language, current_gdbarch);
}

static struct type *
type_system_address (void)
{
  struct type *type 
    = language_lookup_primitive_type_by_name (current_language,
					      current_gdbarch, 
					      "system__address");
  return  type != NULL ? type : lookup_pointer_type (builtin_type_void);
}

void
_initialize_ada_exp (void)
{
  obstack_init (&temp_parse_space);
}

/* FIXME: hilfingr/2004-10-05: Hack to remove warning.  The function
   string_to_operator is supposed to be used for cases where one
   calls an operator function with prefix notation, as in 
   "+" (a, b), but at some point, this code seems to have gone
   missing. */

struct stoken (*dummy_string_to_ada_operator) (struct stoken) 
     = string_to_operator;
