#ifndef BISON_CP_NAME_PARSER_H
# define BISON_CP_NAME_PARSER_H

#ifndef YYSTYPE
typedef union
  {
    struct demangle_component *comp;
    struct nested {
      struct demangle_component *comp;
      struct demangle_component **last;
    } nested;
    struct {
      struct demangle_component *comp, *last;
    } nested1;
    struct {
      struct demangle_component *comp, **last;
      struct nested fn;
      struct demangle_component *start;
      int fold_flag;
    } abstract;
    int lval;
    struct {
      int val;
      struct demangle_component *type;
    } typed_val_int;
    const char *opname;
  } yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	FLOAT	258
# define	NAME	259
# define	STRUCT	260
# define	CLASS	261
# define	UNION	262
# define	ENUM	263
# define	SIZEOF	264
# define	UNSIGNED	265
# define	COLONCOLON	266
# define	TEMPLATE	267
# define	ERROR	268
# define	NEW	269
# define	DELETE	270
# define	OPERATOR	271
# define	STATIC_CAST	272
# define	REINTERPRET_CAST	273
# define	DYNAMIC_CAST	274
# define	SIGNED_KEYWORD	275
# define	LONG	276
# define	SHORT	277
# define	INT_KEYWORD	278
# define	CONST_KEYWORD	279
# define	VOLATILE_KEYWORD	280
# define	DOUBLE_KEYWORD	281
# define	BOOL	282
# define	ELLIPSIS	283
# define	RESTRICT	284
# define	VOID	285
# define	FLOAT_KEYWORD	286
# define	CHAR	287
# define	WCHAR_T	288
# define	ASSIGN_MODIFY	289
# define	TRUEKEYWORD	290
# define	FALSEKEYWORD	291
# define	DEMANGLER_SPECIAL	292
# define	CONSTRUCTION_VTABLE	293
# define	CONSTRUCTION_IN	294
# define	GLOBAL	295
# define	OROR	296
# define	ANDAND	297
# define	EQUAL	298
# define	NOTEQUAL	299
# define	LEQ	300
# define	GEQ	301
# define	LSH	302
# define	RSH	303
# define	UNARY	304
# define	INCREMENT	305
# define	DECREMENT	306
# define	ARROW	307


extern YYSTYPE yylval;

#endif /* not BISON_CP_NAME_PARSER_H */
